% GENERAZIONE DI TUTTE LE COPPIE DI MATRICI Aijkw e Bijkw
function [Amatrix, Bmatrix] = getMatrix
    global M m J d g r;
    
    % N O T E   P R E L I M I N A R I :
    % theta =>      [-pi/4, pi/4]
    % thetaDot =>   [-alfa, alfa]
    alfa = 1;
    
    % M O D E L L O :
    % x'(t) = SOMME * SOMME * SOMME * SOMME ( Ei(z1(t) * Mj(z2(t)) * Nk(z3(t)) * Sw(z4(t)) )
    %         i=1,2   j=1,2   k=1,2   w=1,2
    %           
    %         * ( Aijkw * x(t) + Bijkw * C(t))
    
    % D O V E :
    
    % z1(t) = 1 / [(M + m) * (J + m * d^2) - (m^2 * d^2  * cos(theta)^2)]
    z1max = 1 / ((M + m) * (J + m * d^2) - m^2 * d^2);
    z1min = 1 / ((M + m) * (J + m * d^2) - m^2 * d^2 * cos(1.5359)^2);
    % q sulla documentazione
    z1index = zeros(1,2);
    z1index(1) = z1max;
    z1index(2) = z1min;
    % E1(z1(t)) = (z1(t) - q2) / (q1 - q2)
    % E2(z1(t)) = (q1 - z1(t)) / (q1 - q2)
    
    % z2(t) = sin(theta)
    z2max = 1;
    z2min = 2 / pi;
    % b sulla documentazione
    z2index = zeros(1,2);
    z2index(1) = z2max;
    z2index(2) = z2min;
    % M1(z2(t)) = (z2(t) - b2) / (b1 - b2)
    % M2(z2(t)) = (b1 - z2(t)) / (b1 - b2)
    
    % z3(t) = thetaDot * sin (2 * theta)
    z3max = alfa;
    z3min = -alfa;
    % c sulla documentazione
    z3index = zeros(1,2);
    z3index(1) = z3max;
    z3index(2) = z3min;
    % N1(z3(t)) = (z3(t) - c2) / (c1 - c2)
    % N2(z3(t)) = (c1 - z3(t)) / (c1 - c2)
    
    % z4(t) = cos(theta)
    z4max = 1;
    z4min = cos(1.5359);
    % d sulla documentazione
    z4index = zeros(1,2);
    z4index(1) = z4max;
    z4index(2) = z4min;
    % S1(z4(t)) = (z4(t) - d2) / (d1 - d2)
    % S2(z4(t)) = (d1 - z4(t)) / (d1 - d2)
    
    Amatrix = zeros(2,2,16);
    Bmatrix = zeros(2,1,16);
    index = 1;
    
    for i=1:2
        for j=1:2
            for k=1:2
                for w=1:2
                    Amatrix(:,:,index) = getA(z1index(i), z2index(j), z3index(k));
                    Bmatrix(:,:,index) = getB(z1index(i), z4index(w));
                    index = index + 1;
                end
            end
        end
    end

% get Aijkw matrix
% zi indica il valore max o min di zi
function  y = getA(z1,z2,z3)
    global M m d g;
    % coefficienti moltiplivativi della generica matrice Aijkw
    a11 = 0;
    a12 = 1;
    a21 = -(M + m) * g * m * d;
    a22 = m^2 * d^2 / 2;
    
    y = zeros(2,2);
    y(1,1) = a11;
    y(1,2) = a12;
    y(2,1) = a21 * z1 * z2;
    y(2,2) = a22 * z1 * z3;

% get Bijkw matrix
function y = getB(z1,z4)
    global m d r;
    % coefficienti moltiplivativi della generica matrice Bijkw
    b11 = 0;
    b21 = - (m * d) / r;
    
    y = zeros(2,1);
    y(1,1) = b11;
    y(2,1) = b21 * z1 * z4;